Subject: Re: linux-next: manual merge of the xen-tip tree with the tip tree

From: Peter Zijlstra <[email-masked]>
Date: Wed, 12 Aug 2015 19:21:05 +0200

On Wed, Aug 12, 2015 at 09:27:38AM -0400, Boris Ostrovsky wrote:

> Incidentally, 11276d53 ("locking/static_keys: Add a new static_key
> interface") breaks old-ish compilers (gcc version 4.4.4 20100503 (Red Hat
> 4.4.4-2) (GCC)):
> 
> 
> 
>   CC      arch/x86/kernel/nmi.o
> In file included from
> /home/build/linux-boris/include/linux/jump_label.h:109,
>                  from
> /home/build/linux-boris/arch/x86/include/asm/spinlock.h:5,
>                  from /home/build/linux-boris/include/linux/spinlock.h:88,
>                  from /home/build/linux-boris/arch/x86/kernel/nmi.c:14:
> /home/build/linux-boris/arch/x86/include/asm/jump_label.h: In function
> ‘nmi_handle’:
> /home/build/linux-boris/arch/x86/include/asm/jump_label.h:21: warning: asm
> operand 0 probably doesn’t match constraints
> /home/build/linux-boris/arch/x86/include/asm/jump_label.h:21: error:
> impossible constraint in ‘asm’
> make[3]: *** [arch/x86/kernel/nmi.o] Error 1
> make[2]: *** [arch/x86/kernel] Error 2
> make[1]: *** [arch/x86] Error 2

Ugh bugger.

I bet its that: &((char *)key)[branch] business, an earlier variant
thereof tripped up more recent GCCs too.

So its an __always_inline function, and both argument are always compile
time constants, @key is the address of an object in static storage (a
global) and @branch is a simple 0/1 at the call site.

Now we wish to compute (unsigned long)key + branch at compile/link time
to feed to the assembler as an immediate, which should be possible,
given its all 'constants'.

It just appears GCC is having a hard time with this.

Let me see if I have a sufficiently old GCC around to play with.